import resources as Res
import rcStatus
import time
from rcGlobalEnv import rcEnv
from collector import Collector

class ResSvc(Res.Resource):
    def __init__(self,
                 rid=None,
                 name=None,
                 type="master",
                 always_on=set([]),
                 optional=False,
                 disabled=False,
                 tags=set([]),
                 restart=0,
                 monitor=False,
                 subset=None):
        Res.Resource.__init__(self,
                              rid,
                              "svc",
                              optional=optional,
                              disabled=disabled,
                              always_on=always_on,
                              tags=tags,
                              restart=restart,
                              monitor=monitor,
                              subset=subset)
        self.name = name
        self.type = type

    def start(self):
	if self.type != "master":
            return
        o = Collector(self.svc.node.options, self.svc.node.collector)
        while True:
            try:
                d = o.collector_service_status(self.name)
            except Exception as e:
                self.log.warning("unable to fetch master service '%s' state. collector error: %s ... skip wait" % (self.name, str(e)))
                return
            s = d[self.name]["availstatus"]
            if s == "up":
                self.log.warning("master service '%s' is up" % self.name)
                break
            self.log.warning("master service '%s' state is '%s' ... wait" % (self.name, s))
            time.sleep(5)

    def _status(self, verbose=False):
        o = Collector(self.svc.node.options, self.svc.node.collector)
        #d = o.collector_service_status(self.name)
        try:
            d = o.collector_service_status(self.name)
            #d = self.svc.node.collector.collector_service_status(self.name)
        except Exception as e:
            self.status_log("collector error: %s" % str(e))
            return rcStatus.UNDEF
        if self.name not in d:
            self.status_log("the collector does'nt know about this service")
            return rcStatus.UNDEF
        return rcStatus.status_value(d[self.name]['availstatus'])
